diff a/test/lib/org/openjdk/asmtools/jasm/CFVersion.java b/test/lib/org/openjdk/asmtools/jasm/CFVersion.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/jasm/CFVersion.java
@@ -0,0 +1,104 @@
+/*
+ * Copyright (c) 2017, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools.jasm;
+
+/*
+ * Class File Version
+ */
+public class CFVersion implements Cloneable{
+    /**
+     * Default versions of class file
+     */
+    public static final short DEFAULT_MAJOR_VERSION = 45;
+    public static final short DEFAULT_MINOR_VERSION = 3;
+    public static final short DEFAULT_MODULE_MAJOR_VERSION = 53;
+    public static final short DEFAULT_MODULE_MINOR_VERSION = 0;
+    public static final short UNDEFINED_VERSION = -1;
+
+    private short major_version;
+    private short minor_version;
+    private boolean frozen;
+    private boolean isSet;
+
+    public CFVersion() {
+        frozen = false;
+        isSet = false;
+        major_version = UNDEFINED_VERSION;
+        minor_version = UNDEFINED_VERSION;
+    }
+
+    public CFVersion(boolean frozenCFV, short major_version, short minor_version) {
+        isSet = true;
+        frozen = frozenCFV;
+        this.major_version = major_version;
+        this.minor_version = minor_version;
+    }
+
+    public void setMajorVersion(short major_version) {
+        if ( !frozen ) {
+            isSet = true;
+            this.major_version = major_version;
+        }
+    }
+
+    public void setMinorVersion(short minor_version) {
+        if (!frozen) {
+            isSet = true;
+            this.minor_version = minor_version;
+        }
+    }
+
+    public String asString() {
+        return (isSet) ? this.major_version + ":" +this.minor_version : "(undef):(undef)";
+    }
+
+    public void initModuleDefaults() {
+        if( ! isSet) {
+            major_version = DEFAULT_MODULE_MAJOR_VERSION;
+            minor_version = DEFAULT_MODULE_MINOR_VERSION;
+        }
+    }
+
+    public void initClassDefaults() {
+        if( !isSet ) {
+            major_version = DEFAULT_MAJOR_VERSION;
+            minor_version = DEFAULT_MINOR_VERSION;
+        }
+    }
+
+    public short minor_version() {
+        return this.minor_version;
+    }
+
+    public short major_version() {
+        return this.major_version;
+    }
+
+    public CFVersion clone() {
+        try {
+            return (CFVersion)super.clone();
+        } catch (CloneNotSupportedException e) {
+            throw new RuntimeException(e);
+        }
+    }
+}
diff a/test/lib/org/openjdk/asmtools/jasm/CPXAttr.java b/test/lib/org/openjdk/asmtools/jasm/CPXAttr.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/jasm/CPXAttr.java
@@ -0,0 +1,48 @@
+/*
+ * Copyright (c) 1996, 2014, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools.jasm;
+
+import java.io.IOException;
+
+/**
+ * Constant Pool Index Attribute
+ */
+class CPXAttr extends AttrData {
+
+    Argument cell;
+
+    public CPXAttr(ClassData cls, String attrName, Argument cell) {
+        super(cls, attrName);
+        this.cell = cell;
+    }
+
+    public int attrLength() {
+        return 2;
+    }
+
+    public void write(CheckedDataOutputStream out) throws IOException {
+        super.write(out);  // attr name, attr len
+        out.writeShort(cell.arg);
+    }
+} // end class CPXAttr
+
diff a/test/lib/org/openjdk/asmtools/jasm/CheckedDataOutputStream.java b/test/lib/org/openjdk/asmtools/jasm/CheckedDataOutputStream.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/jasm/CheckedDataOutputStream.java
@@ -0,0 +1,64 @@
+/*
+ * Copyright (c) 2014, 2017, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+
+/*
+ * To change this template, choose Tools | Templates
+ * and open the template in the editor.
+ */
+package org.openjdk.asmtools.jasm;
+
+import java.io.DataOutput;
+import java.io.IOException;
+
+/**
+ *
+ */
+public interface CheckedDataOutputStream {
+
+    public void write(int b) throws IOException;
+
+    public void write(byte b[], int off, int len) throws IOException;
+
+    public void writeBoolean(boolean v) throws IOException;
+
+    public void writeByte(int v) throws IOException;
+
+    public void writeShort(int v) throws IOException;
+
+    public void writeChar(int v) throws IOException;
+
+    public void writeInt(int v) throws IOException;
+
+    public void writeLong(long v) throws IOException;
+
+    public void writeFloat(float v) throws IOException;
+
+    public void writeDouble(double v) throws IOException;
+
+    public void writeBytes(String s) throws IOException;
+
+    public void writeChars(String s) throws IOException;
+
+    public void writeUTF(String s) throws IOException;
+
+}
diff a/test/lib/org/openjdk/asmtools/jasm/ClassArrayAttr.java b/test/lib/org/openjdk/asmtools/jasm/ClassArrayAttr.java
--- /dev/null
+++ b/test/lib/org/openjdk/asmtools/jasm/ClassArrayAttr.java
@@ -0,0 +1,69 @@
+/*
+ * Copyright (c) 2020, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ */
+package org.openjdk.asmtools.jasm;
+
+import java.io.IOException;
+import java.util.List;
+
+/**
+ * Base class of the "classes[]" data of attributes
+ * <p>
+ * JEP 181 (Nest-based Access Control): class file 55.0
+ * NestMembers_attribute {
+ * u2 attribute_name_index;
+ * u4 attribute_length;
+ * u2 number_of_classes;
+ * u2 classes[number_of_classes];
+ * }
+ * <p>
+ * JEP 360 (Sealed types): class file 59.65535
+ * PermittedSubclasses_attribute {
+ * u2 attribute_name_index;
+ * u4 attribute_length;
+ * u2 number_of_classes;
+ * u2 classes[number_of_classes];
+ * }
+ */
+public class ClassArrayAttr extends AttrData {
+
+    List<ConstantPool.ConstCell> classes;
+
+    public ClassArrayAttr(String attributeName, ClassData cdata, List<ConstantPool.ConstCell> classes) {
+        super(cdata, attributeName);
+        this.classes = classes;
+    }
+
+    @Override
+    public int attrLength() {
+        return 2 + classes.size() * 2;
+    }
+
+    @Override
+    public void write(CheckedDataOutputStream out) throws IOException {
+        super.write(out);
+        out.writeShort(classes.size());
+        for (ConstantPool.ConstCell c : classes) {
+            out.writeShort(c.arg);
+        }
+    }
+}
